
 { to read file with condition vector for the satellite
   and to obtain difference between eiler orbit and numerical results }

 UNIT UnForDif ;

 INTERFACE

 Procedure ToGetDifPosition ( strgr  : String ) ;

 IMPLEMENTATION

 Uses
   UnConTyp , { type and constants }
   UnForKep , { from cartesian to keplerian }
   UnForEil , { from cartesian to eilerian }
   UnHarMod , { for GemParmValue[1..4] }
   UnForFun , { ATanDegree }
   UnForPrt ; { PrtFile }

 Var
   valelm  : Array [1..3] of Extended ;
   valmin  : Array [1..3] of Extended ;
   valmax  : Array [1..3] of Extended ;
   ceil    : TEilerP ;

 { some information about min and max residuals to PrtFile }

 Procedure PrtMinMaxPos ( telm , tcur  : Extended ) ;
 Begin
   If  ( ( Round(tcur-telm) mod 86400 ) = 0 )
     Then { PrtFile from UnForPrt }
       WriteLn(PrtFile,tcur/86400.0:6:1,
                       1.0e-6*valmax[1]:22:16,
                       1.0e-6*valmax[2]:22:16,1.0e-6*valmax[3]:22:16);
 End;

 Procedure ToObtainMinMaxDifPos ;
 Var
   i     : Byte ;
   tcur  : Extended ;
   posa  : TVect3 ;
   vela  : TVect3 ;
   posb  : TVect3 ;
   velb  : TVect3 ;
   difp  : TVect3 ;
   telm  : Extended ;
   angl  : Extended ;
   angg  : Extended ;
   angh  : Extended ;
   ancl  : Extended ;
   ancg  : Extended ;
   anch  : Extended ;
 Begin
   For i:=1 To 4 Do  ceil[i]:=GemParmValue[i];
   ToReSetPosVelFile ;
   ReadLn(RomFile,telm); { initial moment in second }
   ReadLn(RomFile,posa[1],posa[2],posa[3]); { position in km }
   ReadLn(RomFile,vela[1],vela[2],vela[3]); { velosity in km/s }
   FromCartToEiler(posa,vela,ceil,angl,angg,angh); { initial Eiler elements }
   For i:=1 To 3 Do
     Begin
       valmax[i]:=-1.0e10;
       valmin[i]:=+1.0e10;
     End;
   ToReSetPosVelFile ;
   While  NOT SeekEOF(RomFile)  Do
     Begin
       ReadLn(RomFile,tcur); { moment in second }
       ReadLn(RomFile,posa[1],posa[2],posa[3]); { position in km }
       ReadLn(RomFile,vela[1],vela[2],vela[3]); { velosuty in km/s }
       ancl:=angl+ceil[24]*(tcur-telm); { current eiler angle l }
       ancg:=angg+ceil[25]*(tcur-telm); { current eiler angle g }
       anch:=angh+ceil[26]*(tcur-telm); { current eiler angle h }
       FromEilerToCart(ceil,ancl,ancg,anch,posb,velb);
       For i:=1 To 3 Do  difp[i]:=posb[i]-posa[i]; { position differences km }
       For i:=1 To 3 Do  valelm[i]:=1.0e6*difp[i]; { from km to mm }
       For i:=1 To 3 Do
         Begin
           If  valmax[i] < valelm[i]  Then  valmax[i]:=valelm[i];
           If  valmin[i] > valelm[i]  Then  valmin[i]:=valelm[i];
         End;
       PrtMinMaxPos(telm,tcur);
     End;
   Close(RomFile);
 End;

 { to read descart position and velosity from RomFile
   and to compare with ones
   that have been obtained by using Eiler elements }

 Procedure ToGetDifPosition ( strgr  : String ) ;
 Var
   bop  : Boolean ;
   chp  : Char ;
 Begin
   WriteLn(PrtFile);
   WriteLn(PrtFile,'intermediate orbit minus ',
                   'numerical integration results');
   WriteLn(PrtFile,'maximum residuals of positions in kilometer');
   WriteLn(PrtFile,' ':3,'day',' ':16,'dx  km',
                   ' ':16,'dy  km',' ':16,'dz  km');
   Assign(RomFile,strgr);
   ToObtainMinMaxDifPos ;
 End;

 END.
